import { resolve } from 'path';
import { searchForConfigFile } from '../utils/paths';
import { CommandError } from '../utils/error';

export enum UseBasePathReturnCode {
	COULD_NOT_FIND_CONFIG_FILE = -1,
}

export const useBasePath = async (...args: string[]) => {
	const basePathPrefix = await searchForConfigFile();

	if (typeof basePathPrefix !== 'string') {
		throw new CommandError(
			UseBasePathReturnCode.COULD_NOT_FIND_CONFIG_FILE,
			'Could not find config file',
		);
	}

	const basePath = resolve(basePathPrefix, ...args);
	process.stdout.write(`Using base path: ${basePath}\n`);
	return basePath;
};
